(function ($) {
    jQuery(window).on('elementor/frontend/init', function () {
        class E_Addons_Form_Custom_Js extends elementorModules.frontend.handlers.Base {
            getDefaultSettings() {
                return {
                    selectors: {
                        form: '.elementor-form:not(.e-form-no-ajax-actions)',
                    },
                };
            }
            getDefaultElements() {
                const selectors = this.getSettings('selectors');
                let elements = {};
                elements.$form = this.$element.find(selectors.form);
                this.elements = elements;
                return elements;
            }
            handleSubmit(event) {
                event.preventDefault();
                //console.log('submit');
                this.handleCustomJsExecution(event);
                //return false;
            }
            handleCustomJsExecution(event) {
                var self = this,
                $form = this.elements.$form;
                if ($form.length) {
                    //console.log('customjs...');
                    setTimeout(function () {
                        let message = $form.find('.elementor-message');
                        if (message.length) {
                            //console.log('show message');                         

                            if (self.settings.e_form_script_success) {
                                if (!message.hasClass('elementor-message-success')) {
                                    return false;
                                }
                            }

                            var custom_js_code = false;
                            let $scope = jQuery(self.$element);
                            let custom_js = $scope.find('.elementor-form-custom-js');
                            if (custom_js.length) {
                                custom_js_code = custom_js.html();
                            }

                            if (message.find('.elementor-form-custom-js-processed').length) {
                                custom_js_code = message.find('.elementor-form-custom-js-processed').html();
                                message.find('.elementor-form-custom-js-processed').remove();
                            }

                            //console.log('execute custom js');     
                            //console.log(custom_js_code);
                            if (custom_js_code) {
                                //custom_js_code = decodeURI(custom_js_code);
                                custom_js_code = jQuery("<div/>").html(custom_js_code).text();
                                console.log(custom_js_code);
                                eval(custom_js_code);
                            }

                        } else {
                            self.handleCustomJsExecution(event);
                        }
                    }, 100);
                }
            }
            bindEvents() {
                let $scope = jQuery(this.$element);
                this.settings = $scope.data('settings');
                this.elements.$form.on('submit', this.handleSubmit.bind(this));                
            }
        }
        const E_Addons_Form_Custom_Js_Handler = ($element) => {
            // wait until steps are ready
            setTimeout(function () {
                elementorFrontend.elementsHandler.addHandler(E_Addons_Form_Custom_Js, {
                    $element,
                });
            }, 100);
        };

        elementorFrontend.hooks.addAction('frontend/element_ready/form.default', E_Addons_Form_Custom_Js_Handler);
    });
})(jQuery, window);